--------------------------------------------------------------------------------
-- Title				:	Simple 4-bit ALU
-- Project			:	Sample code
-- File				:	ALU_4bit.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	A simple 4-bit ALU with four operations.
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity ALU_4bit is
    Port ( A 	: in std_logic_vector(3 downto 0);	-- 1st operand
           B 	: in std_logic_vector(3 downto 0);	-- 2nd operand
           Op 	: in std_logic_vector(1 downto 0);	-- operation select
           Y 	: out std_logic_vector(7 downto 0)); -- result
end ALU_4bit;

architecture Behavioral of ALU_4bit is

begin

y	<= ("0000" & A) + ("0000" & B)  when op="00" else 	-- A + B
		("0000" & A) - ("0000" & B)  when op="01" else	-- A - B 
		(A * B)  						  when op="10" else	-- A * B 
		(A & B);														-- bypass		


end Behavioral;
