--------------------------------------------------------------------------------
-- Title				:	Binary to gray converter
-- Project			:	Sample code
-- File				:	bin_gray.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:  4-bit Binary to gray converter
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity bin_gray is
    Port ( bin 		: in std_logic_vector(3 downto 0);
           gray 		: out std_logic_vector(3 downto 0));
end bin_gray;

architecture Behavioral of bin_gray is
begin

gray(3)	<=	bin(3);	
gray(2)	<=	bin(3) xor	bin(2);	
gray(1)	<=	bin(2) xor	bin(1);	
gray(0)	<=	bin(0) xor	bin(1);	

end Behavioral;
