 -------------------------------------------------------------------------------
-- Title				:	3:8 Decoder with active High O/P	
-- Project			:	Sample code
-- File				:	decoder.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	3:8 decoder with 3 enables. Models the 74xx238 IC	
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.std_logic_ARITH.ALL;
use IEEE.std_logic_UNSIGNED.ALL;

entity decoder is
    Port ( a : in std_logic_vector(2 downto 0);	-- Address I/Ps
           e1 : in std_logic;					-- Active LOW enable
           e2 : in std_logic;					-- Active LOW enable
           e3 : in std_logic;					-- Active HIGH enable
           y : out bit_vector(7 downto 0));		-- Active High O/Ps
end decoder;

architecture Behavioral of decoder is
signal y_s	: bit_vector(7 downto 0);
signal a_int	: integer range 0 to 7;
begin

a_int	<= conv_integer(a);

y_s	<= "00000001" sll a_int;

Y	<= y_s when e1='0' and e2='0' and e3='1' else
	   (others=>'0');

end Behavioral;
