-------------------------------------------------------------------------------
-- Title				:	Parity generator
-- Project			:	Sample code
-- File				:	par_gen.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	8-bit parity generator
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity par_gen is
    Port ( 
				din 	:	 in std_logic_vector(7 downto 0);
           	peven	: 	 out std_logic;
           	podd 	: 	 out std_logic
		  );

end par_gen;

architecture Behavioral of par_gen is
begin

process(din)
variable y:std_logic;
begin
y:='0';
for i in 0 to 7 loop
y := din(i) xor y;
end loop;

peven	<= not y;
podd	<= y;
end process;

end Behavioral;
