--------------------------------------------------------------------------------
-- Title				:	Pos.Edge Trig.4bit UpCounter.
-- Project			:	Sample code
-- File				:	cntr_4bit.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	positive edge triggered 4-bit binary up counter
--						USDP has Active 'LOW' Reset
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity cntr_4 is
Port 
( 
	clk 	: in std_logic;
  	rst 	: in std_logic;
  	q		: out std_logic_vector(3 downto 0)
);
		
end cntr_4;

architecture Behavioral of cntr_4 is
signal count1 :	std_logic_vector(3 downto 0);
begin

-- process for counter
process(clk,rst)
begin
if rst = '0' then
	count1<=(others=>'0');
elsif(clk'event and clk='1')then
	count1<=count1 + '1';
end if ;
end process;
   
q	<= count1;
end Behavioral;