--------------------------------------------------------------------------------
-- Title				:	Dff with sync. Reset.
-- Project			:	Sample code
-- File				:	dff_syn.vhd
-------------------------------------------------------------------------------
-- Organization	:	ni logic PVt. Ltd., Pune, India
-------------------------------------------------------------------------------
-- Description		:	DFF with synchronous reset
--						USDP has Active 'LOW' Reset
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity dff_syn is
Port ( 
		clk	: 	in std_logic;
		rst	: 	in std_logic;
      din	: 	in std_logic;
      q	 	: 	out std_logic

	   );
end dff_syn;

architecture Behavioral of dff_syn is

begin

process(clk,rst)
begin
if(clk'event and clk='1')then
	if(rst='0')then
		q<='0';
	else
		q<=din;
	end if;
end if;      
end process;



end Behavioral;